#version 130
precision highp float;
#define NONE 0
#define VERTICAL 1
#define HORIZONTAL 2


const vec4 Contrast = vec4(0.5f, 0.5f, 0.5f, 1.0f);
const vec4 Brightness = vec4(2.0f, 2.0f, 2.0f, 2.0f);

uniform sampler2D texture;
uniform int direction;
uniform float ddSize;

in vec2 frag_texCoord;

out vec4 fragColor;

vec4 gauss(sampler2D yTexture, vec2 yUV, float yDD, int yDirection)
{
	//Initialisierungen
	float wights[7];
		wights[0] = 0.015625;
		wights[1] = 0.09375;
		wights[2] = 0.234375;
		wights[3] = 0.3125;
		wights[4] = 0.234375;
		wights[5] = 0.09375;
		wights[6] = 0.015625;
	
	vec2 offsets[7];
	if(yDirection == VERTICAL)
	{
		offsets[0] = vec2(yDD*-3.0, 0.0);
		offsets[1] = vec2(yDD*-2.0, 0.0);
		offsets[2] = vec2(yDD*-1.0, 0.0);
		offsets[3] = vec2(0.0, 0.0);
		offsets[4] = vec2(yDD*1.0, 0.0);
		offsets[5] = vec2(yDD*2.0, 0.0);
		offsets[6] = vec2(yDD*3.0, 0.0);
	}
	else //  HORIZONTAL
	{
		offsets[0] = vec2(0.0, yDD*-3.0);
		offsets[1] = vec2(0.0, yDD*-2.0);
		offsets[2] = vec2(0.0, yDD*-1.0);
		offsets[3] = vec2(0.0, 0.0);
		offsets[4] = vec2(0.0, yDD*1.0);
		offsets[5] = vec2(0.0, yDD*2.0);
		offsets[6] = vec2(0.0, yDD*3.0);
	}

	vec4 outp = vec4(0.0, 0.0, 0.0, 0.0);

	// Texturen auslesen
	//vec2 tempUV;
	vec4 tempColor; 
	//float dipth;
	for(int i=0; i<7; i++)
	{
		//tempUV = yUV + offsets[i];
		//if(tempUV.x > 0.0f && tempUV.x < 1.0f && tempUV.y > 0.0f && tempUV.y < 1.0f)
		//{
			tempColor = texture2D(yTexture, yUV + offsets[i]);
			//dipth = 1.0f/tempColor.a;
			//outp += wights[i] * texture2D(yTexture, yUV + offsets[i]) * tempColor.a;
			//outp += wights[i] * tempColor * tempColor.a;
			outp += wights[i] * tempColor;
		//}
	}
	
	return outp;
}

vec4 saturate(vec4 inp)
{
	return clamp(inp, vec4(0.0f, 0.0f, 0.0f, 0.0f), vec4(1.0f, 1.0f, 1.0f, 1.0f));
}

vec4 pushGlow(sampler2D yTexture, vec2 yUV)
{
	
	//Initialisierungen
	vec4 outp = vec4(0.0, 0.0, 0.0, 0.0);

	// Texturen auslesen
	outp = texture2D(yTexture, yUV);

	//Kontrast
	vec4 c = vec4(2.0,2.0,2.0,1.0) * (vec4(1.0,1.0,1.0,1.0) - Contrast);
	outp = saturate((outp - vec4(0.5,0.5,0.5,0.5)) * c + vec4(0.5,0.5,0.5,0.5));

	//Farben pushen
	outp *= Brightness;

	//Helligkeit
	vec4 b = (vec4(1.0,1.0,1.0,1.0) - Contrast * vec4(2.0,2.0,2.0,1.0));
	outp = saturate(outp + b);

	return outp;
}

void main()
{
	/*vec2 uvCoord = frag_texCoord;
	//uvCoord.x = uvCoord.x + 0.1f;
	fragColor = texture2D(texture, frag_texCoord);
	*/
	if(direction == NONE)
	{
		fragColor = texture2D(texture, frag_texCoord);
		/*if(frag_texCoord.y > 1.0f) 
			fragColor = vec4(0.0f, 0.0f, 1.0f, 1.0f);
		else
			fragColor = pushGlow(texture, frag_texCoord);
			*/
		
	}
	else
	{
		fragColor = gauss(texture, frag_texCoord, ddSize, direction);
		//fragColor.a = 1.0f; // fr den zweiten durchgang alles gleich stark geweichten
		//fragColor = vec4(1.0,1.0,1.0,1.0);
	}
}