#version 130
precision highp float;

uniform sampler2D texture_color;
uniform sampler2D texture_normal;

uniform vec4 diffuseColor;
uniform vec4 specColor;
uniform float ref;
uniform float spec;
uniform float hard;
uniform float alpha;
uniform float emit;

in vec2 frag_texCoord;
in vec3 frag_eyeVector;
in vec3 frag_lightVector[5];
in vec3 frag_normal;

out vec4 fragColor;
out vec4 mbControll;

void main()
{
	vec3 normal = (texture2D(texture_normal, frag_texCoord.st).rgb * 2.0f - vec3(1.0f, 1.0f, 1.0f)) * 1.0f;
	float diffuse = 0.0f;
	float specular = 0.0f;
	
	for (int i = 0; i < 5; i++)
	{
		vec3 lightVector = normalize(frag_lightVector[i]);
		
		diffuse += max(0.0f, dot(normal, lightVector));
		
		if (dot(normal, lightVector) > 0)
		{
			specular += pow(max(0.0f, dot(reflect(-lightVector, normal), normalize(frag_eyeVector))), hard);
		}
	}
	
	diffuse = max(0.2f, min(1.0f, diffuse * ref + emit));
	specular = min(1.0f, specular * spec);
	
	fragColor = texture2D(texture_color, frag_texCoord.st) * diffuse + specColor * specular;
	//fragColor = vec4(fragColor.rgb, 0.0f);
	fragColor = vec4(fragColor.rgb, alpha);
	
	mbControll = mbControll = vec4(0.0, 0.0f, 0.0f, 0.0f);
}



/*uniform sampler2D texture_color;

uniform vec4 diffuseColor;
uniform vec4 specColor;
uniform float ref;
uniform float spec;
uniform float hard;
uniform float alpha;
uniform vec4 cameraPos;

in vec4 world_position;
in vec3 world_normal;
in vec2 world_texCoord;

out vec4 fragColor;

void main()
{
	vec3 lightpos = vec3(0.0f, 0.0f, 20.0f);
	vec3 pos = world_position.xyz / (world_position.w);
	
	vec3 lightdir = normalize(lightpos - pos);
	
	vec4 diffuse = texture2D(texture_color, world_texCoord.st) * min(1.0f, (ref * max(0.0f, dot(normalize(world_normal), lightdir))) + 0.2);
	
	float specfac = 0;	
	
	if (dot(world_normal, lightdir) > 0)
	{
		vec3 eye3 = (cameraPos.xyz / cameraPos.w) - pos;
		vec3 refvec = reflect(lightdir, normalize(world_normal)).xyz * -1;
		
		eye3 = normalize(eye3);
		refvec = normalize(refvec);
		
		if (dot(eye3, refvec) > 0)
		{
			specfac = pow(dot(eye3, refvec), hard);
		}
	}
	
	if (specfac < 0)
		specfac = 0;
	
	vec4 specular = specColor * min(1.0f, spec * specfac);

	fragColor =  diffuse + specular;
}*/